package sorryGame;

import java.util.ArrayList;
import java.util.Map;
public class EasyComputerPlayer extends ComputerPlayer {

    public EasyComputerPlayer(GameBoard board, String color) {
        super(board, color);
    }

    @Override
    public void move(int card) {
        System.out.println(getColor());
        Map<String, Pawn[]> pawnMap = board.getPawns();
        ArrayList<Pawn> opponents = board.getOpponentPawns(this.getOpponents());
        for (Map.Entry<String, Pawn[]> pawns : pawnMap.entrySet()) {
            if (pawns.getKey().equalsIgnoreCase(getColor())) {
                for (Pawn pawn : pawns.getValue()) {
                    switch(card){
                        case 0:
                            if (pawn.getLocation() == -1) {
                                int destination = pawn.startIndex;
                                for(Pawn p : opponents){
                                    if(p.getLocation() >= 0 && p.getLocation() < 60){
                                        if((destination - pawn.getLocation() +60)%60 < (destination - p.getLocation() + 60)%60){
                                            board.makeMove(card, pawn.getID(), pawn.getLocation(), p.getLocation());
                                            if (pawn.getLocation() < pawn.safetyIndex) pawn.setDistanceHome(pawn.safetyIndex - pawn.getLocation());
                                            else {pawn.setDistanceHome((pawn.safetyIndex + 60) - pawn.getLocation());}
                                            System.out.println("distance home " + pawn.distanceHome + ", Location " + pawn.getLocation() + ", ID" + pawn.getID());
                                            return;
                                        }
                                    }
                                }
                            }
                            break;
                        case 11:
                            if(pawn.getLocation() >= 0 && pawn.getLocation() < 60){
                                int distance = pawn.distanceHome + 6, temp;
                                Pawn closest = pawn;
                                if(pawn.getLocation() >= 0 && pawn.getLocation() < 60 ){
                                    for(Pawn p : opponents){
                                        if (p.getLocation() >= 0 && p.getLocation() < 60 ){
                                            if(p.getLocation() <= pawn.safetyIndex){ temp = (pawn.safetyIndex+6) - p.getLocation();}
                                            else{ temp = ((pawn.safetyIndex + 66) - p.getLocation());}
                                            if(temp < distance){closest = p; distance = temp;}
                                        }
                                    }
                                    if ((temp = (pawn.getLocation() + card)) <= (pawn.safetyIndex + 6)){temp = (pawn.safetyIndex + 6) - temp;}
                                    if ((distance) >= temp){closest = pawn; distance = temp;}
                                    board.makeMove(card, pawn.getID(), pawn.getLocation(), closest.getLocation());
                                    if (pawn.getLocation() < pawn.safetyIndex) pawn.setDistanceHome(pawn.safetyIndex - pawn.getLocation());
                                    else {pawn.setDistanceHome((pawn.safetyIndex + 60) - pawn.getLocation());}
                                    return;
                                }
                            }
                            if (pawn.distanceHome < 5) {break;}
                            else if (pawn.getLocation() > Integer.parseInt(pawn.homeArray[0].getPositionID())){break;}
                            else break;
                        default:
                            // if a move does not result in a bump ]
                            System.out.println(pawn.getLocation());
                            if (pawn.getLocation() == -1 && (card == 1 || card == 2) && !board.getGameArray()[pawn.startIndex].isOccupied()) {
                                board.makeMove(card, pawn.getID(), pawn.getLocation(), pawn.startIndex);
                                pawn.setDistanceHome(58);
                                System.out.println("distance home " + pawn.distanceHome + ", Location " + pawn.getLocation() + ", ID" + pawn.getID());
                                return;
                            }
                            else if (pawn.getLocation() >= Integer.parseInt(pawn.homeArray[0].getPositionID()) && ((card + pawn.getLocation()) <= pawn.homeIndex)){
                                board.makeMove(card, pawn.getID(), pawn.getLocation(), (pawn.getLocation() + card));
                                return;
                            }
                            else if (pawn.distanceHome >= (card - 6) && pawn.distanceHome < card ){
                                board.makeMove(card, pawn.getID(), pawn.getLocation(), Integer.parseInt(pawn.homeArray[((card - pawn.distanceHome)-1)].getPositionID()) );
                                pawn.distanceHome = 0;
                                pawn.setArray(pawn.homeArray);
                                System.out.println("distance home " + pawn.distanceHome + ", Location " + pawn.getLocation() + ", ID" + pawn.getID());
                                return;
                            }
                            else if (pawn.getLocation() >= 0 && pawn.getLocation() <= 59) {
                                if(pawn.distanceHome >= card){
                                    if (!board.willBumpPiece(card, pawn.getLocation())) {
                                        if (board.validateMove(card, pawn.getID(), pawn.getLocation(),
                                                               ((pawn.getLocation() + card) % 60), 0, 0)) {
                                            //make rthe first move that results in a bump
                                            board.makeMove(card, pawn.getID(), pawn.getLocation(),
                                                           ((pawn.getLocation() + card) % 60));
                                            if (pawn.getLocation() <= pawn.safetyIndex) pawn.setDistanceHome(pawn.safetyIndex - pawn.getLocation());
                                            else {pawn.setDistanceHome((pawn.safetyIndex + 60) - pawn.getLocation());}
                                            System.out.println("distance home " + pawn.distanceHome + ", Location " + pawn.getLocation() + ", ID" + pawn.getID());
                                            return;
                                        }
                                    }
                                    else {
                                        System.out.println("should move " + pawn.getID() + " from " + pawn.getLocation() +  " to " + ((pawn.getLocation() + card) % 60));
                                        board.makeMove(card, pawn.getID(), pawn.getLocation(), ((pawn.getLocation() + card) % 60));
                                        if (pawn.getLocation() < pawn.safetyIndex) pawn.setDistanceHome(pawn.safetyIndex - pawn.getLocation());
                                        else {pawn.setDistanceHome((pawn.safetyIndex + 60) - pawn.getLocation());}
                                        System.out.println("distance home " + pawn.distanceHome + ", Location " + pawn.getLocation() + ", ID" + pawn.getID());
                                        return;
                                    }
                                }
                                else break;
                            }

                    }
                }
            }
        }
    }
}
