package sorryGame; /**
 * CS 205 Program: sorryGame.GameApplet Programmer: Christopher Morse Date: 3/21/12
 */

import netscape.javascript.JSException;
import netscape.javascript.JSObject;

import java.applet.Applet;
import java.util.List;

@SuppressWarnings("UnusedDeclaration")
public class GameApplet extends Applet {

    public SorryGame game;
    public HumanPlayer humanPlayer;
    public ComputerPlayer computerPlayer, computerPlayer2;
    private JSObject window;
    public boolean valid;
    private int tempToPosition;
    private int tempFromPosition;
    Player currentPlayer;

    public void start() {
        try {
            this.window = JSObject.getWindow(this);
        }
        catch (JSException jse) {jse.printStackTrace();}
    }

    /**
     *
     * @param pieceID   DOM 'id' of the piece being moved. Passed from javascript.
     * @param fromPosition    DOM 'id' of the position the piece passed in pieceID currently occupies.
     * @param toPosition      DOM 'id' of the position the player wishes to move the piece passed in pieceID.
     * @return isValid  True if the move was valid and completed successfully; False if the move was invalid or there
     *                  was an error.
     */
    public boolean validateMove(String pieceID, String fromPosition, String toPosition) throws Exception {

        if(fromPosition.equals("gstart") || fromPosition.equals("rstart") || fromPosition.equals("bstart") || fromPosition.equals("ystart"))
        fromPosition = "-1";
        else if (toPosition.equals("greenhome")) toPosition = "65";
        else if (toPosition.equals("redhome")) toPosition = "71";
        else if (toPosition.equals("bluehome")) toPosition = "77";
        else if (toPosition.equals("yellowhome")) toPosition = "83";
        int fromPosition2;
        int toPosition2;

        if (game.currentCard.getRank() == 7){
            if(((Integer.parseInt(toPosition) - Integer.parseInt(fromPosition)) % 60) == 7){
                fromPosition2 = 0;
                toPosition2 = 0;
                System.out.println("Card rank equal 7, part 1.");
                valid = game.validateMove(pieceID, Integer.parseInt(fromPosition), Integer.parseInt(toPosition),
                                          fromPosition2, toPosition2);
            }
            else if ((((((Integer.parseInt(toPosition) - Integer.parseInt(fromPosition))%60)+60)%60) < 7)  && tempToPosition== 0 && tempFromPosition == 0) {
                tempFromPosition= Integer.parseInt(fromPosition);
                tempToPosition = Integer.parseInt(toPosition);
                int remaining = ((((Integer.parseInt(toPosition) - Integer.parseInt(fromPosition)) % 60) + 60) % 60);
                String message = "You need to move another piece " + remaining + " spaces to complete your turn.";
                window.call("sevenCard", new Object[]{message});
                valid = false;
            }
            else if ((((((Integer.parseInt(toPosition) - Integer.parseInt(fromPosition))%60)+60)%60) < 7)  && (tempToPosition != 0 || tempFromPosition != 0)){
                fromPosition2 = Integer.parseInt(fromPosition);
                toPosition2 = Integer.parseInt(toPosition);
                valid = game.validateMove(pieceID, Integer.parseInt(fromPosition), Integer.parseInt(toPosition),
                                          fromPosition2, toPosition2);
                if (valid) {
                    String message = "You have finished with the 7 card move";
                    window.call("sevenCard", new Object[]{message});
                }
                tempFromPosition = 0; tempToPosition = 0;
            }
        }
        else{
            fromPosition2 = 0;
            toPosition2 = 0;
            valid = game.validateMove(pieceID, Integer.parseInt(fromPosition), Integer.parseInt(toPosition),
                                      fromPosition2, toPosition2);
        }

        System.out.printf("Before Validate: pieceID: %s, fromPosition: %d, toPosition: %d%n", pieceID, Integer.parseInt(fromPosition),
                          Integer.parseInt(toPosition));

        if (valid) {
            updatePositions(game.board.getStartArrays(), "start");
            updatePositions(game.board.getGameArray(), "game");
            updatePositions(game.board.getGreenHomeArray(), "g");
            updatePositions(game.board.getRedHomeArray(), "r");
            updatePositions(game.board.getBlueHomeArray(), "b");
            updatePositions(game.board.getYellowHomeArray(), "y");
        }
        return valid;
    }

    public boolean computerTurn() throws Exception {
        window.call("setCurrentPlayer", new Object[]{computerPlayer.getName()});
        int card = drawCard();
        window.call("changeCard", new Object[]{card});
        computerPlayer.move(card);
        updatePositions(game.board.getStartArrays(), "start");
        updatePositions(game.board.getGameArray(), "game");
        updatePositions(game.board.getGreenHomeArray(), "g");
        updatePositions(game.board.getRedHomeArray(), "r");
        updatePositions(game.board.getBlueHomeArray(), "b");
        updatePositions(game.board.getYellowHomeArray(), "y");
        window.call("setCurrentPlayer", new Object[]{humanPlayer.getName()});
        return true;
    }

    /**
     * Updates all of the positions on the board using the state information contained in the 'gameArray'.
     * @return  updateComplete  True if update is successful; False otherwise.
     */
    public boolean updatePositions(PlayableSquare[] array, String filingName) throws Exception {
        boolean updateComplete = false;
        String pieceID, toIndex;
        for (sorryGame.PlayableSquare square : array) {
            if (square.isOccupied()) {
                if (square.getType().equals("start")) {
                    List<String> idList = square.getPlayerIDList();
                    for (String s : idList) {
                        pieceID = s;
                        toIndex = square.getPositionID();
                        System.out.printf("pieceID: %s, finalPosition: %s%n", pieceID, toIndex);
                        window.call("movePiece", new Object[]{pieceID, toIndex});
                    }
                }
                else if (square.getType().equals("home")){
                    if (square.getColor().equals("green")) { toIndex = "greenhome"; }
                    else if (square.getColor().equals("red")) { toIndex = "redhome"; }
                    else if (square.getColor().equals("blue")) { toIndex = "bluehome"; }
                    else { toIndex = "yellowhome"; }
                    List<String> idList = square.getPlayerIDList();
                    for (String s : idList) {
                        pieceID = s;
                        System.out.printf("pieceID: %s, finalPosition: %s%n", pieceID, toIndex);
                        window.call("movePiece", new Object[]{pieceID, toIndex});
                    }
                    if (square.getNumOccupants() == 4){
                        if (square.getColor().equals(humanPlayer.getColor())){
                            window.call("finishGame", new Object[]{1});
                        }
                        else window.call("finishGame", new Object[]{0});
                    }
                }
                else{
                    pieceID = square.getPlayerPieceID();
                    toIndex = square.getPositionID();
                    System.out.printf("pieceID: %s, finalPosition: %s%n", pieceID, toIndex);
                    window.call("movePiece", new Object[]{pieceID, toIndex});
                }
            }
        }
        return updateComplete;
    }
//    public boolean startGame() {
//        game = new SorryGame();
//        computerPlayer2 = new EasyComputerPlayer(game.board, "blue");
//        computerPlayer = new EasyComputerPlayer(game.board, "yellow");
//        game.board.addPlayer(computerPlayer);
//        game.board.addPlayer(computerPlayer2);
//        return true;
//    }

    public boolean startGame(String name, String color, String difficulty) {
        game = new SorryGame();
        humanPlayer = new HumanPlayer(game.board);
        humanPlayer.setName(name);
        humanPlayer.setColor(color);
        game.board.addPlayer(humanPlayer);
        if (difficulty.equals("easy")) {
            computerPlayer = new EasyComputerPlayer(game.board, "blue");
            game.board.addPlayer(computerPlayer);
        }
        else {
            computerPlayer = new EasyComputerPlayer(game.board, "yellow");
            game.board.addPlayer(computerPlayer);
        }
        return true;

    }

    public boolean startGame() {
        game = new SorryGame();
        computerPlayer = new EasyComputerPlayer(game.board, "blue");
        computerPlayer2 = new EasyComputerPlayer(game.board, "yellow");
        game.board.addPlayer(computerPlayer);
        game.board.addPlayer(computerPlayer2);
        return true;
    }

    /**
     * Returns next String value of next card in the deck.
     *
     */
    public int drawCard(){
        return game.drawCard();
    }
}